package com.webchat.aigc.consumer.rocketmq;

import com.webchat.aigc.llm.AiAgentFlowService;
import org.apache.rocketmq.spring.annotation.MessageModel;
import org.apache.rocketmq.spring.annotation.RocketMQMessageListener;
import org.apache.rocketmq.spring.core.RocketMQListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * 当前对话消息队列，因为需要WebSocket或SSE服务端主动推送，为了解决分布式websocketsession及ssemetter共享问题，这里必须广播模式
 */
@Component
@RocketMQMessageListener(consumerGroup = "web_chat", topic = "queue_chat_robot", messageModel = MessageModel.BROADCASTING)
public class RobotChatRocketQueueConsumer implements RocketMQListener<String> {

    @Autowired
    private AiAgentFlowService aiAgentFlowService;

    /**
     * 处理来自IM 对话相关消息
     *
     * @param message
     */
    @Override
    public void onMessage(String message) {

        aiAgentFlowService.doAgent(message);
    }
}